/***************************************************************************
 *
 * Copyright (c) 1997-2011 CRI Middlware Co., LTD.
 *
 * Appli.   : ADX Decoder
 * Module   : Library
 * File     : adxdcd.h
 *
 ***************************************************************************/


#ifndef _ADXDCD_H_INCLUDED
#define _ADXDCD_H_INCLUDED

#if !defined(_TYPEDEF_Uint8)
#define _TYPEDEF_Uint8
typedef unsigned char			Uint8;		/* ȂPoCg */
#endif

#if !defined(_TYPEDEF_Sint8)
#define _TYPEDEF_Sint8
typedef signed char				Sint8;		/* PoCg */
#endif

#if !defined(_TYPEDEF_Uint16)
#define _TYPEDEF_Uint16
typedef unsigned short			Uint16;		/* ȂQoCg */
#endif

#if !defined(_TYPEDEF_Sint16)
#define _TYPEDEF_Sint16
typedef signed short			Sint16;		/* QoCg */
#endif

#if !defined(_TYPEDEF_Uint32)
#define _TYPEDEF_Uint32
typedef unsigned long			Uint32;		/* ȂSoCg */
#endif

#if !defined(_TYPEDEF_Sint32)
#define _TYPEDEF_Sint32
typedef signed long				Sint32;		/* SoCg */
#endif


#if !defined(_TYPEDEF_Float32)
#define _TYPEDEF_Float32
typedef float					Float32;		/* SoCg */
#endif

#if !defined(_TYPEDEF_Float64)
#define _TYPEDEF_Float64
typedef double					Float64;		/* WoCg */
#endif

#if !defined(_TYPEDEF_Fixed32)
#define _TYPEDEF_Fixed32
typedef signed long				Fixed32;		/* Œ菬_32rbg */
#endif

/* NULL |C^^ */
#if !defined(NULL)
#ifdef __cplusplus
#define NULL	(0)
#else
#define NULL	((void *)0)
#endif
#endif


typedef struct _adxHeaderInfo {
	Sint16 dlen;		// wb_
	Sint8 code;
	Sint8 bps;
	Sint8 blksize;
	Sint8 nch;			// `l 1:Mono 2:Ste
	Sint32 sfreq;		// TvOg
	Sint32 total_nsmpl;	// Tv
	Sint32 nsmpl_blk;

	Sint16 k[2];		// Wl
	Sint16 dly_l[2];	// fBCl L
	Sint16 dly_r[2];	// fBCl R
} AdxHeaderInfo;

/*
֐dl
*/

#ifdef __cplusplus
extern "C" {
#endif
// ADXwb_̉
Sint8 *ADX_AnalyzeHeaderInfo(Sint8 *ibuf, Sint32 ibuflen, AdxHeaderInfo *inf);
// PubÑfR[h
Sint8 *ADX_DecodeBlock(Sint8 *ptr, Sint16 *obuf, Sint16 *dly, Sint16 *k);
#ifdef __cplusplus
}
#endif

#endif

/* end of file */
